module mdy_fifo_1_5(
    clk_in      ,
    clk_out     ,
    rst_n       ,

    data_in_vld ,
    data_in     ,
    b_rdy       ,

    data_out_vld,
    data_out     
    );

    parameter      DIN_W  =         8;
    parameter      DOUT_W =        32;

    input                clk_in          ;   
    input                clk_out         ;   
    input                rst_n           ;
                                 
    input                data_in_vld     ;
    input[DIN_W-1:0]     data_in         ;
    input                b_rdy           ;
                              
    output               data_out_vld    ;
    output[DOUT_W-1:0]   data_out        ;
    reg                  data_out_vld    ;
    reg   [DOUT_W-1:0]   data_out        ;
    reg [ 1:0]           cnt0            ;
    wire                 add_cnt0        ;
    wire                 end_cnt0        ;
    reg                  wrreq           ;
    reg[DOUT_W-1:0]      data            ;
    wire [DOUT_W-1:0]    q               ;
    wire                 rdempty         ;
    wire[5:0]            wrusedw         ;
    wire                 rdreq           ;



always @(posedge clk_in or negedge rst_n) begin 
    if (rst_n==0) begin
        cnt0 <= 0; 
    end
    else if(add_cnt0) begin
        if(end_cnt0)
            cnt0 <= 0; 
        else
            cnt0 <= cnt0+1 ;
   end
end
assign add_cnt0 = data_in_vld ;
assign end_cnt0 = add_cnt0  && cnt0 == 4-1 ;


always  @(posedge clk_in or negedge rst_n)begin
    if(rst_n==1'b0)begin
        wrreq <= 0;
    end
    else if(wrusedw>=61) begin
        wrreq <= 0;
    end
    else begin
        wrreq <= end_cnt0;
    end
end

always  @(posedge clk_in or negedge rst_n)begin
    if(rst_n==1'b0)begin
        data <= 0;
    end
    else if(add_cnt0) begin
        /*
        if(cnt0==0)
            data[15:8] <= data_in ;
        else
            data[7:0] <= data_in;

        */
        data[DOUT_W-1-cnt0*8 -:8] <= data_in;
    end
end







fifo_ahead#(.DATA_W(DOUT_W),.DEPT_W(64)) u_fifo(
	.aclr    (~rst_n    ) ,
    .data    (data      ) ,
	.rdclk   (clk_out   ) ,
	.rdreq   (rdreq     ) ,
	.wrclk   (clk_in    ) ,
	.wrreq   (wrreq     ) ,
    .q       (q         ) ,
    .rdempty (rdempty   ) ,
    .wrusedw (wrusedw   )   
	);

assign rdreq = rdempty==0 && b_rdy==1; 


always  @(posedge clk_out or negedge rst_n)begin
    if(rst_n==1'b0)begin
        data_out <= 0;
    end
    else begin
        data_out <= q;
    end
end

always  @(posedge clk_out or negedge rst_n)begin
    if(rst_n==1'b0)begin
        data_out_vld <= 0;
    end
    else begin
        data_out_vld <= rdreq ;
    end
end



endmodule

